    //
//  ServicesListViewController.m
//  uPnp2
//
//  Created by rk on 29/01/11.
//  Copyright 2011 Interchart. All rights reserved.
//

#import "ServicesTableViewController.h"


@implementation ServicesTableViewController

@synthesize services, tableView;


- (id) init {
	self = [super initWithNibName:@"ServicesTableView" bundle:nil];
	return self;
}

 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
	self = [self init];
//    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
//    if (self) {
//        // Custom initialization.
//    }
    return self;
}

-(void) setServices:(NSMutableArray *)newServices {
	services = newServices;
	NSArray *subViews = [self.view subviews];
	for (UIView *subView in subViews) {
		NSLog(@"subview=%@", subView);
		if ([subView isKindOfClass:[UITableView class]]) {
			tableView = (UITableView *)subView;
		}
	}
	tableView.delegate = self;
	tableView.dataSource = self;
	[tableView reloadData];
}

#pragma mark -
-(IBAction)hideView {
	[self.view removeFromSuperview];
}

#pragma mark -
#pragma mark Table view delegate

- (void)tableView:(UITableView *)aTableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
    
    /*
     When a row is selected, set the detail view controller's detail item to the item associated with the selected row.
     */
	//int sectionNr = indexPath.section;
	int rowNr = indexPath.row;
	UpnpAvService *service = [services objectAtIndex:rowNr];
	NSLog(@"Service: %@\n  serviceId:%@\n  serviceType:%@\n  SCPDURL:%@\n  controlURL:%@\n  eventSubURL:%@",
		  service,
		  service.serviceId,
		  service.serviceType,
		  service.SCPDURL,
		  service.controlURL,
		  service.eventSubURL
		  );
}

#pragma mark -
#pragma mark UITableViewDataSource protocol
- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
	return [services count];
	
}


- (UITableViewCell *)tableView:(UITableView *)theTableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    
    static NSString *CellIdentifier = @"CellIdentifier";
    
    // Dequeue or create a cell of the appropriate type.
    UITableViewCell *cell = [theTableView dequeueReusableCellWithIdentifier:CellIdentifier];
    if (cell == nil) {
        cell = [[[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:CellIdentifier] autorelease];
        cell.accessoryType = UITableViewCellAccessoryNone;
    }
    
    // Configure the cell.
	//int sectionNr = indexPath.section;
	int rowNr = indexPath.row;

	//cell.textLabel.text = [NSString stringWithFormat:@"%@",[services objectAtIndex:rowNr]];
	UpnpAvService *service = [services objectAtIndex:rowNr];
	NSString *serviceId = service.serviceId; // : separated components
	NSString *lastComponent = [[serviceId componentsSeparatedByString:@":"] lastObject];
	cell.textLabel.text = lastComponent;
	//	UpnpAvService *service = (UpnpAvService *)[services objectAtIndex:rowNr];
//	NSString *serviceType = service.serviceType;
//	cell.textLabel.text = [NSString stringWithFormat:@"%@", serviceType];
	
    return cell;	
}


#pragma mark -


/*
// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];
}
*/


- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Overriden to allow any orientation.
    return YES;
}


- (void)didReceiveMemoryWarning {
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc. that aren't in use.
}


- (void)viewDidUnload {
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}


- (void)dealloc {
    [super dealloc];
}


@end
